1. Packages
  2. Packages
  3. Pulumi Cloud (Pulumi Service provider)
  4. API Docs
  5. api
  6. api/esc
  7. EnvironmentSchedule

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi
pulumiservice logo

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi

    Creates a new scheduled action for a Pulumi ESC environment. Schedules can be used to automate recurring operations on environments, such as secret rotation. The request body specifies the schedule timing and the action to perform. Returns the created ScheduledAction on success. Requires the secret rotation feature to be enabled for the organization.

    Create EnvironmentSchedule Resource

    Resources are created with functions called constructors. To learn more about declaring and configuring resources, see Resources.

    Constructor syntax

    new EnvironmentSchedule(name: string, args: EnvironmentScheduleArgs, opts?: CustomResourceOptions);
    @overload
    def EnvironmentSchedule(resource_name: str,
                            args: EnvironmentScheduleArgs,
                            opts: Optional[ResourceOptions] = None)
    
    @overload
    def EnvironmentSchedule(resource_name: str,
                            opts: Optional[ResourceOptions] = None,
                            env_name: Optional[str] = None,
                            org_name: Optional[str] = None,
                            project_name: Optional[str] = None,
                            schedule_cron: Optional[str] = None,
                            schedule_id: Optional[str] = None,
                            schedule_once: Optional[str] = None,
                            secret_rotation_request: Optional[Any] = None)
    func NewEnvironmentSchedule(ctx *Context, name string, args EnvironmentScheduleArgs, opts ...ResourceOption) (*EnvironmentSchedule, error)
    public EnvironmentSchedule(string name, EnvironmentScheduleArgs args, CustomResourceOptions? opts = null)
    public EnvironmentSchedule(String name, EnvironmentScheduleArgs args)
    public EnvironmentSchedule(String name, EnvironmentScheduleArgs args, CustomResourceOptions options)
    
    type: pulumiservice:api/esc:EnvironmentSchedule
    properties: # The arguments to resource properties.
    options: # Bag of options to control resource's behavior.
    
    
    resource "pulumiservice_api_esc_environmentschedule" "name" {
        # resource properties
    }

    Parameters

    name string
    The unique name of the resource.
    args EnvironmentScheduleArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resource.
    args EnvironmentScheduleArgs
    The arguments to resource properties.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resource.
    args EnvironmentScheduleArgs
    The arguments to resource properties.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resource.
    args EnvironmentScheduleArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resource.
    args EnvironmentScheduleArgs
    The arguments to resource properties.
    options CustomResourceOptions
    Bag of options to control resource's behavior.

    Constructor example

    The following reference example uses placeholder values for all input properties.

    var environmentScheduleResource = new PulumiService.Api.Esc.EnvironmentSchedule("environmentScheduleResource", new()
    {
        EnvName = "string",
        OrgName = "string",
        ProjectName = "string",
        ScheduleCron = "string",
        ScheduleID = "string",
        ScheduleOnce = "string",
        SecretRotationRequest = "any",
    });
    
    example, err := esc.NewEnvironmentSchedule(ctx, "environmentScheduleResource", &esc.EnvironmentScheduleArgs{
    	EnvName:               pulumi.String("string"),
    	OrgName:               pulumi.String("string"),
    	ProjectName:           pulumi.String("string"),
    	ScheduleCron:          pulumi.String("string"),
    	ScheduleID:            pulumi.String("string"),
    	ScheduleOnce:          pulumi.String("string"),
    	SecretRotationRequest: pulumi.Any("any"),
    })
    
    resource "pulumiservice_api_esc_environmentschedule" "environmentScheduleResource" {
      env_name                = "string"
      org_name                = "string"
      project_name            = "string"
      schedule_cron           = "string"
      schedule_id             = "string"
      schedule_once           = "string"
      secret_rotation_request = "any"
    }
    
    var environmentScheduleResource = new EnvironmentSchedule("environmentScheduleResource", EnvironmentScheduleArgs.builder()
        .envName("string")
        .orgName("string")
        .projectName("string")
        .scheduleCron("string")
        .scheduleID("string")
        .scheduleOnce("string")
        .secretRotationRequest("any")
        .build());
    
    environment_schedule_resource = pulumiservice.api.esc.EnvironmentSchedule("environmentScheduleResource",
        env_name="string",
        org_name="string",
        project_name="string",
        schedule_cron="string",
        schedule_id="string",
        schedule_once="string",
        secret_rotation_request="any")
    
    const environmentScheduleResource = new pulumiservice.api.esc.EnvironmentSchedule("environmentScheduleResource", {
        envName: "string",
        orgName: "string",
        projectName: "string",
        scheduleCron: "string",
        scheduleID: "string",
        scheduleOnce: "string",
        secretRotationRequest: "any",
    });
    
    type: pulumiservice:api/esc:EnvironmentSchedule
    properties:
        envName: string
        orgName: string
        projectName: string
        scheduleCron: string
        scheduleID: string
        scheduleOnce: string
        secretRotationRequest: any
    

    EnvironmentSchedule Resource Properties

    To learn more about resource properties and how to use them, see Inputs and Outputs in the Architecture and Concepts docs.

    Inputs

    In Python, inputs that are objects can be passed either as argument classes or as dictionary literals.

    The EnvironmentSchedule resource accepts the following input properties:

    EnvName string
    The environment name
    OrgName string
    The organization name
    ProjectName string
    The project name
    ScheduleCron string
    The schedule cron
    ScheduleID string
    The schedule ID
    ScheduleOnce string
    The schedule once
    SecretRotationRequest object
    The secret rotation request
    EnvName string
    The environment name
    OrgName string
    The organization name
    ProjectName string
    The project name
    ScheduleCron string
    The schedule cron
    ScheduleID string
    The schedule ID
    ScheduleOnce string
    The schedule once
    SecretRotationRequest interface{}
    The secret rotation request
    env_name string
    The environment name
    org_name string
    The organization name
    project_name string
    The project name
    schedule_cron string
    The schedule cron
    schedule_id string
    The schedule ID
    schedule_once string
    The schedule once
    secret_rotation_request any
    The secret rotation request
    envName String
    The environment name
    orgName String
    The organization name
    projectName String
    The project name
    scheduleCron String
    The schedule cron
    scheduleID String
    The schedule ID
    scheduleOnce String
    The schedule once
    secretRotationRequest Object
    The secret rotation request
    envName string
    The environment name
    orgName string
    The organization name
    projectName string
    The project name
    scheduleCron string
    The schedule cron
    scheduleID string
    The schedule ID
    scheduleOnce string
    The schedule once
    secretRotationRequest any
    The secret rotation request
    env_name str
    The environment name
    org_name str
    The organization name
    project_name str
    The project name
    schedule_cron str
    The schedule cron
    schedule_id str
    The schedule ID
    schedule_once str
    The schedule once
    secret_rotation_request Any
    The secret rotation request
    envName String
    The environment name
    orgName String
    The organization name
    projectName String
    The project name
    scheduleCron String
    The schedule cron
    scheduleID String
    The schedule ID
    scheduleOnce String
    The schedule once
    secretRotationRequest Any
    The secret rotation request

    Outputs

    All input properties are implicitly available as output properties. Additionally, the EnvironmentSchedule resource produces the following output properties:

    Created string
    The timestamp when this scheduled action was created.
    Definition Dictionary<string, object>
    The action definition, which varies based on the action kind.
    Id string
    The provider-assigned unique ID for this managed resource.
    Kind string
    The kind of action to be executed.
    LastExecuted string
    The timestamp of the last execution, if any.
    Modified string
    The timestamp when this scheduled action was last modified.
    NextExecution string
    The timestamp of the next scheduled execution.
    OrgID string
    The organization ID that owns this scheduled action.
    Paused bool
    Whether the scheduled action is currently paused.
    Created string
    The timestamp when this scheduled action was created.
    Definition map[string]interface{}
    The action definition, which varies based on the action kind.
    Id string
    The provider-assigned unique ID for this managed resource.
    Kind string
    The kind of action to be executed.
    LastExecuted string
    The timestamp of the last execution, if any.
    Modified string
    The timestamp when this scheduled action was last modified.
    NextExecution string
    The timestamp of the next scheduled execution.
    OrgID string
    The organization ID that owns this scheduled action.
    Paused bool
    Whether the scheduled action is currently paused.
    created string
    The timestamp when this scheduled action was created.
    definition map(any)
    The action definition, which varies based on the action kind.
    id string
    The provider-assigned unique ID for this managed resource.
    kind string
    The kind of action to be executed.
    last_executed string
    The timestamp of the last execution, if any.
    modified string
    The timestamp when this scheduled action was last modified.
    next_execution string
    The timestamp of the next scheduled execution.
    org_id string
    The organization ID that owns this scheduled action.
    paused bool
    Whether the scheduled action is currently paused.
    created String
    The timestamp when this scheduled action was created.
    definition Map<String,Object>
    The action definition, which varies based on the action kind.
    id String
    The provider-assigned unique ID for this managed resource.
    kind String
    The kind of action to be executed.
    lastExecuted String
    The timestamp of the last execution, if any.
    modified String
    The timestamp when this scheduled action was last modified.
    nextExecution String
    The timestamp of the next scheduled execution.
    orgID String
    The organization ID that owns this scheduled action.
    paused Boolean
    Whether the scheduled action is currently paused.
    created string
    The timestamp when this scheduled action was created.
    definition {[key: string]: any}
    The action definition, which varies based on the action kind.
    id string
    The provider-assigned unique ID for this managed resource.
    kind string
    The kind of action to be executed.
    lastExecuted string
    The timestamp of the last execution, if any.
    modified string
    The timestamp when this scheduled action was last modified.
    nextExecution string
    The timestamp of the next scheduled execution.
    orgID string
    The organization ID that owns this scheduled action.
    paused boolean
    Whether the scheduled action is currently paused.
    created str
    The timestamp when this scheduled action was created.
    definition Mapping[str, Any]
    The action definition, which varies based on the action kind.
    id str
    The provider-assigned unique ID for this managed resource.
    kind str
    The kind of action to be executed.
    last_executed str
    The timestamp of the last execution, if any.
    modified str
    The timestamp when this scheduled action was last modified.
    next_execution str
    The timestamp of the next scheduled execution.
    org_id str
    The organization ID that owns this scheduled action.
    paused bool
    Whether the scheduled action is currently paused.
    created String
    The timestamp when this scheduled action was created.
    definition Map<Any>
    The action definition, which varies based on the action kind.
    id String
    The provider-assigned unique ID for this managed resource.
    kind String
    The kind of action to be executed.
    lastExecuted String
    The timestamp of the last execution, if any.
    modified String
    The timestamp when this scheduled action was last modified.
    nextExecution String
    The timestamp of the next scheduled execution.
    orgID String
    The organization ID that owns this scheduled action.
    paused Boolean
    Whether the scheduled action is currently paused.

    Package Details

    Repository
    pulumiservice pulumi/pulumi-pulumiservice
    License
    Apache-2.0
    pulumiservice logo

    This provider is currently in preview.

    Viewing docs for Pulumi Cloud v1.1.0
    published on Thursday, May 21, 2026 by Pulumi

      Try Pulumi Cloud free.
      Your team will thank you.

      Start free trial